export declare type Entity<T_Value> = {
    id: string;
    created?: number | undefined;
    deleted?: number | undefined;
} & T_Value;
interface Events<TValue> {
    CREATED: {
        id: string;
        value: TValue | null;
        time: number;
    };
    DELETED: {
        id: string;
        time: number;
    };
    SETTED: {
        id: string;
        value: TValue | null;
        time: number;
    };
}
interface Errors<TValue> {
    ACCESS_INVALID_ENTITY: {
        id: string;
    };
    LOOKUP_NON_INDEXED_FIELD: {
        field: keyof TValue;
    };
}
interface Functions<TValue> {
    create(value: TValue): Promise<[newId: string]>;
    delete(id: string): Promise<void>;
    get(id: string): Promise<Entity<TValue> | undefined>;
    getByIds(ids: string[]): Promise<(Entity<TValue> | undefined)[]>;
}
export declare type EntityServiceSurface<TValue> = {
    errors: Errors<TValue>;
    events: Events<TValue>;
    functions: Functions<TValue>;
};
export {};
//# sourceMappingURL=entity-manager.d.ts.map