import { Collection, WithId } from 'mongodb';
import { BaseService, ServiceInterface } from '../../../core';
import { EntityComponentServiceInterface } from './entity-component';
declare type MongoDoc<T> = {
    _id: string;
    value: T;
};
export interface StringIDEntityComponent<T> {
    id: string;
    value: T;
}
export interface StringIDEntityComponentServiceOptions {
    index?: 'non-unique' | 'unique';
}
export declare class StringIDEntityComponentService<TServiceInf extends ServiceInterface & EntityComponentServiceInterface<T> = any, T = any> extends BaseService<TServiceInf> {
    private _module;
    private _index?;
    private _collection;
    get collection(): Collection<MongoDoc<T>>;
    constructor(options?: StringIDEntityComponentServiceOptions);
    _createIndexes(): Promise<void>;
    protected _parseEntityComponent(doc: WithId<MongoDoc<T>>): StringIDEntityComponent<T>;
    protected _get(id: string): Promise<T | undefined>;
    protected _set(id: string, value: T | undefined): Promise<void>;
    protected _getByIds(ids: string[]): Promise<(T | undefined)[]>;
    protected _getIdByValue(value: T): Promise<string | undefined>;
    protected _getIdsByValue(value: T): Promise<string[]>;
    protected _getAll(): Promise<StringIDEntityComponent<T>[]>;
}
export {};
//# sourceMappingURL=string-id-entity-component.d.ts.map